package contractmanager;

import java.util.Scanner;
import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class ContractFileManager {
    final String archive = "archive.txt";
    final String contracts = "contracts.txt";
    String[] monthString;
    
    void ContractFileManager()
    {
        //Constructor, creates array with months for later use
        monthString = new String[]{"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
    }
    
    //Method for creating a scanner for a given filename
    private Scanner createScanner(String fileName)
    {
        //Creates a scanner if the file is found (and returns it), if not returns null
        Scanner fileScanner;
        try
        {
            fileScanner = new Scanner(new File(fileName));
        }
        catch(FileNotFoundException e)
        {
            return null;
        }
        return fileScanner;
    }
    
    public int fileLineCount(String fileName, int monthSelected)
    {
        //This first section is to detect whether only one month is being searched or not
        //-1 means all months are searched
        boolean allMonths = false;
        if (monthSelected == -1)
        {
            allMonths = true;
        }
        //declares a new scanner to read text file
        Scanner fileScanner = createScanner(fileName);
        if (fileScanner != null)
        {
            int counter = 0;
            boolean isLineNull = false;
            while (!isLineNull)
            {
                try
                {
                    String nextLine = fileScanner.nextLine();
                    //checks to make sure the line contains text, then checks if a specific month is needed to be searched
                    if (!nextLine.equals("") && (allMonths || getMonthInt(nextLine.substring(3, 6)) == monthSelected))
                    {
                        //counter is increased by 1
                        counter++;
                    }
                }
                catch(Exception e)
                {
                    isLineNull = true;        
                }
            }
            fileScanner.close();
            //return the number of lines detected
            return counter;
        }
        else
        {
            return -1;
        }
    }
    
    public int getContractsWithHighUnlimited(String fileName, int monthSelected)
    {
        //This first section is to detect whether only one month is being searched or not
        //-1 means all months are searched
        boolean allMonths = false;
        if (monthSelected == -1)
        {
            allMonths = true;
        }
        Scanner fileScanner = createScanner(fileName);
        if (fileScanner != null)
        {
            int counter = 0;
            boolean isLineNull = false;
            while (!isLineNull)
            {
                try
                {
                    String nextLine = fileScanner.nextLine();
                    //checks to make sure the line contains text, then checks if a specific month is needed to be searched
                    if (!nextLine.equals("") && (allMonths || getMonthInt(nextLine.substring(3, 6)) == monthSelected))
                    {
                        //check if the 2nd element in the line contains 3 or 4, if it does increase the counter by 1
                        String[] splitNextLine = nextLine.split("\t");
                        if (splitNextLine[2].equals("3") || splitNextLine[2].equals("4"))
                        {
                            counter++;
                        }
                    }
                }
                catch(Exception e)
                {
                    isLineNull = true;        
                }
            }
            fileScanner.close();
            return counter;
        }
        else 
        {
            return -1;
        }
    }
    
    public int getAverageOfLargePackages(String fileName, int monthSelected)
    {
        //This first section is to detect whether only one month is being searched or not
        //-1 means all months are searched
        boolean allMonths = false;
        if (monthSelected == -1)
        {
            allMonths = true;
        }
        Scanner fileScanner = createScanner(fileName);
        if (fileScanner != null)
        {
            int counter = 0;
            int totalHigh = 0;
            boolean isLineNull = false;
            while (!isLineNull)
            {
                try
                {
                    String nextLine = fileScanner.nextLine();
                    //checks to make sure the line contains text, then checks if a specific month is needed to be searched
                    if (!nextLine.equals("") && (allMonths || getMonthInt(nextLine.substring(3, 6)) == monthSelected))
                    {
                        //
                        String[] splitNextLine = nextLine.split("\t");
                        if (splitNextLine[1].equals("3"))
                        {
                            //get the first element and add it to the totalHigh var
                            totalHigh = Integer.parseInt(splitNextLine[6]) + totalHigh;
                            counter++;
                        }
                    }
                }
                catch(Exception e)
                {
                    isLineNull = true;
                }
            }
            fileScanner.close();
            //make sure that there's no division by 0! 
            if (counter == 0)
            {
                return 0;
            }
            //return mean in a currency (/100)
            return (int)(totalHigh / counter);
        }
        else
        {
            return -1;
        }
    }
    
    //USED DURING TESTING
    /*public String[] testStringSplit(String fileName, int monthSelected)
    {
        Scanner fileScanner = createScanner(fileName);
        fileScanner.close();
        return fileScanner.nextLine().split("\t");
    }*/
    
    public int[] getCountOfContractsPerMonth(String fileName, int monthSelected)
    {
        //This first section is to detect whether only one month is being searched or not
        //-1 means all months are searched
        boolean allMonths = false;
        if (monthSelected == -1)
        {
            allMonths = true;
        }
        Scanner fileScanner = createScanner(fileName);
        if (fileScanner != null)
        {
            //create an array for all months
            int[] monthCounter = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
            boolean isLineNull = false;
            while (!isLineNull)
            {
                try
                {
                    String nextLine = fileScanner.nextLine();
                    if (!nextLine.equals("") && (allMonths || getMonthInt(nextLine.substring(3, 6)) == monthSelected))
                    {
                        //increases the counter for that month by one
                        monthCounter[getMonthInt(nextLine.substring(3, 6)) - 1]++;
                    }
                }
                catch(Exception e)
                {
                    isLineNull = true;
                }
            }
            fileScanner.close();
            return monthCounter;
        }
        else
        {
            return null;
        }
    }
    
    public List<String[]> getSearchValues(String fileName, String searchValues)
    {
        //create an array list for the results from the search, since it can be many
        List<String[]> totalSearchValues = new ArrayList<String[]>();
        Scanner fileScanner = createScanner(fileName);
        if (fileScanner != null)
        {
            boolean isLineNull = false;
            while (!isLineNull)
            {
                try
                {
                    String nextLine = fileScanner.nextLine();
                    if (!nextLine.equals(""))
                    {
                        String[] splitNextLine = nextLine.split("\t");
                        //if the 5th or 7th element contains the serach value, the line is added to the list
                        if (splitNextLine[5].toLowerCase().contains(searchValues.toLowerCase()) || splitNextLine[7].toLowerCase().contains(searchValues.toLowerCase()))
                        {
                            totalSearchValues.add(splitNextLine);
                        }
                    }
                }
                catch(Exception e)
                {
                    isLineNull = true;
                }
            }
            fileScanner.close();
        }
        //list is then returned
        return totalSearchValues;
    }
    
    //converts a month 3 length string to an integer
    private int getMonthInt(String monthString)
    {
        switch (monthString)
        {
            case "Jan" : return 1;
            case "Feb" : return 2;
            case "Mar" : return 3;
            case "Apr" : return 4;
            case "May" : return 5;
            case "Jun" : return 6;
            case "Jul" : return 7;
            case "Aug" : return 8;
            case "Sep" : return 9;
            case "Oct" : return 10;
            case "Nov" : return 11;
            case "Dec" : return 12;
            default : return 0;
        }
    }
    


}
