package contractmanager;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Locale;
import java.util.Scanner;

public class ContractManager {
    //Public vars
    /* Moved to Contract Class, private
    public static String clientName = "";
    public static int clientPackage = -1;
    public static int clientDataBundle = -1;
    public static String clientReference = "";
    public static int clientPeriod = -1;
    public static boolean clientInternationalCalls = false;
    public static double clientMonthlyRate = -1;
    */
    
    
    public static void main(String[] args) {
        int userInput = -1;
        String userInputString = "";
        Scanner userInputScanner = new Scanner(System.in);
        
        //main menu logic, loop used until the user inputs 0
        while(userInput != 0)
        {
            //displays menu after each option is done
            displayMenu();
            //gets the user input

            userInputString = userInputScanner.nextLine();
            try
            {
                userInput = Integer.parseInt(userInputString);
            }
            catch (Exception e)
            {
                
            }

            //if statements for branching and selecting the option the user asked for
            if (userInput == 1)
            {
                //creates a new contract
                enterNewContract();
            }
            else if (userInput == 2)
            {
                //creates a local scanner for the options of the user
                Scanner userInputScannerLocal = new Scanner(System.in);
                //asks for user input into which file to search
                System.out.println("Please input '1' for contracts.txt, please input '2' for archive.txt: ");
                String fileName;
                if (userInputScannerLocal.hasNext("1"))
                {
                   fileName =  "contracts.txt";
                }
                else
                {
                    fileName =  "archive.txt";
                }
                //prints out the data
                taskReturnData(fileName, -1, 2);
                
            }
            else if (userInput == 3)
            {
                //creates a local scanner for the options of the user
                Scanner userInputScannerLocal = new Scanner(System.in);
                //asks for user input into which file to search
                System.out.println("Please input '1' for contracts.txt, please input '2' for archive.txt: ");
                String fileName;
                if (userInputScannerLocal.hasNext("1"))
                {
                   fileName =  "contracts.txt";
                }
                else
                {
                    fileName =  "archive.txt";
                }
                //asks for the month to search, then executes the search
                System.out.println("Please input the number of the month you wish to search: ");
                int monthSelected = userInputScanner.nextInt();
                taskReturnData(fileName, monthSelected, 3);
            }
            else if (userInput == 4)
            {
                //creates a local scanner for the options of the user
                Scanner userInputScannerLocal = new Scanner(System.in);
                //asks for user input into which file to search
                System.out.println("Please input '1' for contracts.txt, please input '2' for archive.txt: ");
                String fileName;
                if (userInputScannerLocal.hasNext("1"))
                {
                   fileName =  "contracts.txt";
                }
                else
                {
                    fileName =  "archive.txt";
                }
                System.out.println("Please input the search values: ");
                executeSearch(userInputScanner.next(), fileName);
            }
            else if (userInput != 0)
            {
                //show error
                System.out.println("Please enter a valid option.");
            }
        }
        
    }
    
    static void displayMenu()
    {
        //Displays full menu
        System.out.println("1. Enter new Contract");
        System.out.println("2. Display Summary of Contracts");
        System.out.println("3. Display Summary of Contracts for Selected Month");
        System.out.println("4. Find and display Contract");
        System.out.println("0. Exit");
    }
    
    static void enterNewContract()
    {
        //Create new instance of class
        Contract localCon = new Contract();
        
        //Create scanner for user input
        Scanner userInputScanner = new Scanner(System.in);
        
        
        System.out.print("Please enter the client's Name: ");
        while(!localCon.setClientName(userInputScanner.nextLine()))
        {
            //Failed to add data
            System.out.print("Invalid name. Please re-enter the client's name: ");
        }
        
        System.out.print("Please enter the Package: ");
        while (!localCon.setClientPackage(userInputScanner.next()))
        {
            //Failed to add data
            System.out.print("Invalid package. Please re-enter the client's package: ");
        }
        
        System.out.print("Please enter the Data Bundle: ");
        while (!localCon.setClientDataBundle(userInputScanner.next()))
        {
            //Failed to add data
            System.out.print("Invalid Data Bundle. Please re-enter the client's Data Bundle: ");
        }
        
        System.out.print("Please enter the Reference Number: ");
        while(!localCon.setClientReference(userInputScanner.next()))
        {
            //Failed to add data
            System.out.print("Invalid Reference Number. Please re-enter the Reference Number: ");
        }
        
        System.out.print("Please enter the Period: ");
        while(!localCon.setClientPeriod(userInputScanner.next()))
        { 
            //Failed to add data
            System.out.print("Invalid contract period. Please re-enter the Contract Period: ");
        }
        
        System.out.print("Please enter if the client wants International Calls (Y/N): ");
        while(!localCon.setClientInternationalCalls(userInputScanner.next()))
        {
            //Failed to add data
            System.out.print("Invalid selection. Please re-enter International Calls (Y/N): ");
        }
        printContract(localCon);
        //write data to file
        localCon.writeToFile();
        
    }
   
    static void printContract(Contract localCon)
    {
        //get date in correct format for print
        Calendar cal = Calendar.getInstance();
        SimpleDateFormat sdf = new SimpleDateFormat("dd-MMM-yyyy", Locale.ENGLISH);
        
        //print final contract
        System.out.println("|++++++++++++++++++++++++++++++++++++++++++++|");
        System.out.println("|                                            |");
        System.out.println(localCon.formatStringLine(3, "Customer: " + localCon.getClientName(), null));
        System.out.println(localCon.formatStringLine(4, localCon.getClientReference(), sdf.format(cal.getTime())));
        System.out.println(localCon.formatStringLine(5, localCon.getPackageString(localCon.getClientPackage()), localCon.getDataString(localCon.getClientDataBundle())));
        System.out.println(localCon.formatStringLine(6, String.valueOf(localCon.getClientPeriod()).concat(localCon.getClientPeriod() == 1 ? " Month" : " Months"), localCon.getBusinessStatus(localCon.getClientReference())));
        System.out.println("|                                            |");
        System.out.println(localCon.formatStringLine(8, String.valueOf(localCon.getPromotionPercentage() <= 0 ? "None" : localCon.getPromotionPercentage()), localCon.getIntlCallsYesNo(localCon.getClientInternationalCalls())));
        System.out.println("|                                            |");
        System.out.println(localCon.formatStringLine(10, null, null));
        System.out.println("|++++++++++++++++++++++++++++++++++++++++++++|");
    }
    
    //displays the data needed for option 2 & 3
    private static void taskReturnData(String fileName, int monthSelected, int userSelection)
    {
                //calls methods from ContractFileManager class to handle user options
                ContractFileManager cfm = new ContractFileManager();
                int[] monthCounts = cfm.getCountOfContractsPerMonth(fileName, monthSelected);
                String monthResults = "";
                int counter = 0;
                // if the user selection is 2, the month's element needs to be outputted
                if (userSelection == 2)
                {
                    //check every month
                    for (int countedNumber : monthCounts)
                    {
                        int numberOfSpacesNeeded = 4 - Integer.toString(countedNumber).length();
                        monthResults = monthResults + Integer.toString(countedNumber);
                        //string creation
                        while (numberOfSpacesNeeded >= 0)
                        {
                            monthResults = monthResults + " ";
                            numberOfSpacesNeeded--;
                        }
                    }
                }
                //output data
                System.out.println("");
                System.out.println("Total number of contracts: " + cfm.fileLineCount(fileName, monthSelected));
                System.out.println("Contracts with High or Unlimited Data Bundles: " + cfm.getContractsWithHighUnlimited(fileName, monthSelected));
                System.out.println("Average charge for large packages: " + String.format("%.2f", (float)(((float)cfm.getAverageOfLargePackages(fileName, monthSelected) / 100))));
                System.out.println("");
                //only need to output if the user selects 2
                if (userSelection == 2)
                {
                    System.out.println("Jan  Feb  Mar  Apr  May  Jun  Jul  Aug  Sep  Oct  Nov  Dec");
                    System.out.println(monthResults);
                }
    }
    
    private static void executeSearch(String searchString, String fileName)
    {
        ContractFileManager cfm = new ContractFileManager();
        //for each of the results found, print them to the screen
        for (String[] searchResult : cfm.getSearchValues(fileName, searchString))
        {
            Contract localCon = new Contract();
            localCon.setClientName(searchResult[7]);
            localCon.setClientPackage(searchResult[1]);
            localCon.setClientDataBundle(searchResult[2]);
            localCon.setClientReference(searchResult[5]);
            localCon.setClientPeriod(searchResult[3]);
            localCon.setClientInternationalCalls(searchResult[4]);
            printContract(localCon);
        }
    }
    
    
}
